Attribute VB_Name = "Central"
Option Explicit

'/////////////////////////////////////////////////////////////////////////
'Manda a llamar las rutinas de reinicializacin/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub inicio()
 inicio_cotenido
 ini_casillas
 ini_forma
 ini_variables
 tablero.pintar_tablero
End Sub

'/////////////////////////////////////////////////////////////////////////
'Valida el movimiento que el usuario ha hecho/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub movimiento_us(ByVal cas0 As Long, ByVal cas1 As Long)
Dim y1 As Long, x1 As Long, x2 As Long, y2 As Long, x As Long, y As Long

 enrroque_b cas0, cas1
 If enrr_b = uno Then buscar: Exit Sub
 
 y1 = Int(cas0 / ocho) + uno
 x1 = (cas0 - ((y1 - uno) * ocho)) + uno
 y1 = nueve - y1
 y2 = Int(cas1 / ocho) + uno
 x2 = (cas1 - ((y2 - uno) * ocho)) + uno
 y2 = nueve - y2
 
 res_per
 per = True
 movi_blancas4 casilla(), x1, y1
 copiar casilla_au(), casilla()
 movimiento casilla_au(), x1, y1, x2, y2
 calcular_rey casilla_au()
 
 For x = uno To ocho
  For y = uno To ocho
   movi_negras4 casilla_au(), x, y
  Next y
 Next x
 
 If permitido(x2, y2) = uno And tablero.boardsu.Value = cero And permitido2(xrb, yrb) = cero Then
  copiar casilla_au(), casilla()
  movimiento casilla_au(), x1, y1, x2, y2
  If valor2(casilla_au()) < 0 Then Exit Sub
  movimiento casilla(), x1, y1, x2, y2
  tablero.pintar_tablero
  guardar_jugada
  buscar
  Exit Sub
 End If
 
 If tablero.boardsu.Value = uno Then
  movimiento casilla(), x1, y1, x2, y2
  tablero.pintar_tablero
 End If

End Sub

'/////////////////////////////////////////////////////////////////////////
'Genera el movimiento en la matriz mandada y las cuatro coordenadas/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub movimiento(casilla_p() As Long, ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long)
 casilla_p(x2, y2) = casilla_p(x1, y1)
 casilla_p(x1, y1) = cero
End Sub

'/////////////////////////////////////////////////////////////////////////
'Copia el contenido de una matriz a otra/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub copiar(casilla1() As Long, casilla2() As Long)
Dim y As Long, x As Long
 For y = uno To ocho
  For x = uno To ocho
   casilla1(x, y) = casilla2(x, y)
  Next x
 Next y
End Sub

'/////////////////////////////////////////////////////////////////////////
'Evalua el material de cada lado para determinar la etapa del juego/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub evaluar_material(casilla_p() As Long)
Dim x As Long, y As Long

 negras = cero
 blancas = cero
 For y = uno To ocho
  For x = uno To ocho
   If casilla_p(x, y) < cero Then blancas = blancas + uno
   If casilla_p(x, y) > cero Then negras = negras + uno
  Next x
 Next y
 
 If jugada = uno Then estado = uno: Exit Sub
 If jugada = tres Then estado = dos: Exit Sub
 If jugada = cinco Then estado = tres: Exit Sub
 If jugada = siete Then estado = cuatro: Exit Sub
 If blancas > ocho Then: estado = cinco: Exit Sub
 If blancas < nueve Then: estado = seis: Exit Sub
 If negras <= tres Then: estado = siete: Exit Sub

End Sub

'/////////////////////////////////////////////////////////////////////////
'Valua el tablero para que la comp escoja su jugada/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Function valor(casilla_p() As Long) As Single
 Dim x As Long, y As Long, valor_p As Single
 valor_p = cero
 
 For y = uno To ocho
  For x = uno To ocho
   valor_p = valor_p + casilla_p(x, y)
   
   Select Case estado
    Case Is < cuatro:
                If casilla_p(x, y) < cero Then valor_p = valor_p - (uno / (Sqr(((4.5 - x) ^ dos) + ((ocho - y) ^ dos)) + uno))
    Case cinco: If casilla_p(x, y) = caballo Then valor_p = valor_p + (uno / (Sqr(((3.5 - y) ^ dos)) + uno))
                If casilla_p(x, y) = alfil Then valor_p = valor_p + (uno / (Sqr(((3.5 - y) ^ dos)) + uno))
                If casilla_p(x, y) > diez Then valor_p = valor_p + (uno / (Sqr(((4.5 - x) ^ dos) + ((4.5 - y) ^ dos)) + uno))
                If casilla_p(x, y) = reyn Then valor_p = valor_p + y
    Case seis:  If casilla_p(x, y) = diez Then valor_p = valor_p + (dos / y)
                If casilla_p(x, y) > diez And casilla_p(x, y) < 100 Then valor_p = valor_p + (uno / (Sqr(((xrb - x) ^ dos) + ((yrb - y) ^ dos)) + uno))
    Case siete: If casilla_p(x, y) = diez Then valor_p = valor_p + (dos / y)
                If casilla_p(x, y) > diez Then valor_p = valor_p + (uno / (Sqr(((xrb - x) ^ dos) + ((yrb - y) ^ dos)) + uno))
                If casilla_p(x, y) = -reyb Then valor_p = valor_p - (y * 0.1)
   End Select
  
  Next x
 Next y
 
 Select Case estado
 Case uno:   If casilla_p(cuatro, cinco) = diez Then valor_p = valor_p + uno
             If casilla_p(cinco, cinco) = diez Then valor_p = valor_p + uno
             If casilla_p(cuatro, seis) = diez Then valor_p = valor_p + 0.8
             If casilla_p(cinco, seis) = diez Then valor_p = valor_p + 0.8
             If casilla_p(cuatro, cuatro) = -diez And casilla_p(cuatro, cinco) = diez Then valor_p = valor_p + 0.2
             If casilla_p(cinco, cuatro) = -diez And casilla_p(cinco, cinco) = diez Then valor_p = valor_p + 0.2
             If casilla_p(seis, seis) = alfil Then valor_p = valor_p + 0.9
             If casilla_p(tres, seis) = alfil Then valor_p = valor_p + 0.9
 
 Case dos:   If casilla_p(cuatro, seis) = diez Then valor_p = valor_p + uno
             If casilla_p(cinco, seis) = diez Then valor_p = valor_p + uno
             If casilla_p(seis, seis) = caballo Then valor_p = valor_p + 0.9
             If casilla_p(tres, seis) = caballo Then valor_p = valor_p + 0.9
 
 Case tres:  If casilla_p(seis, seis) = caballo Then valor_p = valor_p + 1.2
             If casilla_p(tres, seis) = caballo Then valor_p = valor_p + uno
 
 Case cinco: If casilla_p(seis, seis) = caballo Then valor_p = valor_p + 1.3
             If casilla_p(tres, seis) = caballo Then valor_p = valor_p + uno
             If casilla_p(cuatro, cinco) = diez Then valor_p = valor_p + uno
             If casilla_p(cinco, cinco) = diez Then valor_p = valor_p + uno
             If casilla_p(cuatro, seis) = diez Then valor_p = valor_p + uno
             If casilla_p(cinco, seis) = diez Then valor_p = valor_p + uno
             If casilla_p(siete, ocho) = reyn And casilla_p(seis, ocho) = torre Then valor_p = valor_p + cinco
             If casilla_p(tres, ocho) = reyn And casilla_p(cuatro, ocho) = torre Then valor_p = valor_p + cinco
 End Select
 
 valor = valor_p
End Function

'/////////////////////////////////////////////////////////////////////////
'Valua el tablero para que la comp escoja su jugada/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Function valor2(casilla_p() As Long) As Single
Dim x As Long, y As Long

 valor2 = 0
 For y = uno To ocho
  For x = uno To ocho
   valor2 = valor2 + casilla_p(x, y)
  Next x
 Next y

End Function

'/////////////////////////////////////////////////////////////////////////
'Ordena las pocibles jugadas de las negras de mayor a menor/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub ordenamiento()
Dim valo(200) As Single, valor1 As Single
Dim provi(-uno To diez, -uno To diez) As Long
Dim w As Long, x As Long, y As Long, i As Long, j As Long
 
 res_per
 per = True

 For w = uno To cont_n1
  For y = uno To ocho
   For x = uno To ocho
    provi(x, y) = n1(w, x, y)
   Next x
  Next y: valo(w) = valor(provi())
 Next w
 
 For i = uno To cont_n1 - uno
  For j = (i + uno) To cont_n1
   If valo(i) < valo(j) Then
    valor1 = valo(j): valo(j) = valo(i): valo(i) = valor1
    For y = uno To ocho: For x = uno To ocho: provi(x, y) = n1(j, x, y): Next x: Next y
    For y = uno To ocho: For x = uno To ocho: n1(j, x, y) = n1(i, x, y): Next x: Next y
    For y = uno To ocho: For x = uno To ocho: n1(i, x, y) = provi(x, y): Next x: Next y
   End If
  Next j
 Next i

End Sub

'/////////////////////////////////////////////////////////////////////////
'Ordena las posibles jugadas de las blancas de menor a mayor/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub ordenamiento2()
Dim valo(200) As Single, valor1 As Single
Dim provi(-uno To diez, -uno To diez) As Long
Dim w As Long, x As Long, y As Long, i As Long, j As Long
 
 For w = uno To cont_b1
  For y = uno To ocho
   For x = uno To ocho
    provi(x, y) = b1(w, x, y)
   Next x
  Next y: valo(w) = valor2(provi())
 Next w
 
 For i = uno To cont_b1 - uno
  For j = (i + uno) To cont_b1
   If valo(i) > valo(j) Then
    valor1 = valo(j): valo(j) = valo(i): valo(i) = valor1
    For y = uno To ocho: For x = uno To ocho: provi(x, y) = b1(j, x, y): Next x: Next y
    For y = uno To ocho: For x = uno To ocho: b1(j, x, y) = b1(i, x, y): Next x: Next y
    For y = uno To ocho: For x = uno To ocho: b1(i, x, y) = provi(x, y): Next x: Next y
   End If
  Next j
 Next i

End Sub

'/////////////////////////////////////////////////////////////////////////
'Calcula las posiciones del rey blanco y el rey negro/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub calcular_rey(casilla_p() As Long): Dim y As Long, x As Long
 
 For y = uno To ocho
  For x = uno To ocho
   If casilla_p(x, y) = -reyb Then: xrb = x: yrb = y
   If casilla_p(x, y) = reyn Then: xrn = x: yrn = y
  Next x
 Next y

End Sub

'/////////////////////////////////////////////////////////////////////////
'Guarda la jugada recien realizada en el historial de jugadas/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub guardar_jugada(): Dim x As Long, y As Long
 jugada = jugada + uno
 
 For y = -uno To diez
  For x = -uno To diez
   juego(jugada, x, y) = casilla(x, y)
  Next x
 Next y
 
 tablero.historia.Max = jugada
 tablero.historia.Value = jugada

End Sub

'/////////////////////////////////////////////////////////////////////////
'Resetea la matriz de casillas permitidas/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub res_per()
Dim x As Long, y As Long
 
 For x = uno To ocho
  For y = uno To ocho
   permitido(x, y) = cero
   permitido2(x, y) = cero
  Next y
 Next x

End Sub

'/////////////////////////////////////////////////////////////////////////
'Checa si el usuario se puede enrrocar/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub enrroque_b(cas0 As Long, cas1 As Long)
Dim x As Long, y As Long
 
 enrr_b = 0
 res_per
 per = True

 For y = uno To ocho
  For x = uno To ocho
    movi_negras4 casilla(), x, y
  Next x
 Next y
 
 If cas0 = 60 And cas1 = 62 Then
  If permitido2(cinco, uno) = uno Or permitido2(seis, uno) = uno Or permitido2(siete, uno) = uno Then Exit Sub
  If casilla(cinco, uno) = -reyb And casilla(seis, uno) = 0 And casilla(siete, uno) = 0 And casilla(ocho, uno) = -torre Then
   casilla(cinco, uno) = 0
   casilla(seis, uno) = -torre
   casilla(siete, uno) = -reyb
   casilla(ocho, uno) = 0
   tablero.pintar_tablero
   guardar_jugada
   enrr_b = uno
  End If
 End If
 
 If cas0 = 60 And cas1 = 58 Then
  If permitido2(tres, uno) = uno Or permitido2(cuatro, uno) = uno Or permitido2(cinco, uno) = uno Then: Exit Sub
  If casilla(cinco, uno) = -reyb And casilla(cuatro, uno) = 0 And casilla(tres, uno) = 0 And casilla(dos, uno) = 0 And casilla(uno, uno) = -torre Then
   casilla(cinco, uno) = 0
   casilla(cuatro, uno) = -torre
   casilla(tres, uno) = -reyb
   casilla(dos, uno) = 0
   casilla(uno, uno) = 0
   tablero.pintar_tablero
   guardar_jugada
   enrr_b = uno
  End If
 End If
 
End Sub

'/////////////////////////////////////////////////////////////////////////
'Checa si la comp se puede enrrocar/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub enrroque_n()
Dim x As Long, y As Long

 res_per
 per = True
 
 For y = uno To ocho
  For x = uno To ocho
    movi_blancas4 casilla(), x, y
  Next x
 Next y
 
 copiar casilla_au(), casilla()

 If casilla_au(cinco, ocho) = reyn And casilla_au(seis, ocho) = 0 And casilla_au(siete, ocho) = 0 And casilla_au(ocho, ocho) = torre Then
  If permitido(cinco, ocho) = uno Or permitido(seis, ocho) = uno Or permitido(siete, ocho) = uno Or permitido(ocho, ocho) = uno Then Exit Sub
  casilla_au(siete, ocho) = reyn
  casilla_au(cinco, ocho) = 0
  casilla_au(seis, ocho) = torre
  casilla_au(ocho, ocho) = 0
  cont_n1 = cont_n1 + uno
  
  For y = -uno To diez
   For x = -uno To diez
    n1(cont_n1, x, y) = casilla_au(x, y)
   Next x
  Next y
 End If
 
 If casilla_au(uno, ocho) = torre And casilla_au(dos, ocho) = 0 And casilla_au(tres, ocho) = 0 And casilla_au(cuatro, ocho) = 0 And casilla_au(cinco, ocho) = reyn Then
  If permitido(tres, ocho) = uno Or permitido(cuatro, ocho) = uno Or permitido(cinco, ocho) = uno Then Exit Sub
  casilla_au(uno, ocho) = 0
  casilla_au(dos, ocho) = 0
  casilla_au(tres, ocho) = reyn
  casilla_au(cinco, ocho) = 0
  casilla_au(cuatro, ocho) = torre
  cont_n1 = cont_n1 + uno
  For y = -uno To diez
   For x = -uno To diez
    n1(cont_n1, x, y) = casilla_au(x, y)
   Next x
  Next y
 End If
 
End Sub

'/////////////////////////////////////////////////////////////////////////
'Checa que la computadora no se cicle en la misma jugada/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Function checar_rep(casilla_p() As Long) As Boolean
Dim x As Long, y As Long, jug As Long

 jug = jugada + 1
 If jugada < diez Then checar_rep = False: Exit Function
 checar_rep = True

 For x = uno To ocho
  For y = uno To ocho
   If casilla_p(x, y) > cero Then
    If casilla_p(x, y) <> juego(jug - cuatro, x, y) Then: checar_rep = False: Exit Function
   End If
  Next y
 Next x

 For x = uno To ocho
  For y = uno To ocho
   If juego(jug - dos, x, y) > cero Then
    If juego(jug - dos, x, y) <> juego(jug - seis, x, y) Then: checar_rep = False: Exit Function
   End If
  Next y
 Next x
 
 For x = uno To ocho
  For y = uno To ocho
   If juego(jug - cuatro, x, y) > cero Then
    If juego(jug - cuatro, x, y) <> juego(jug - ocho, x, y) Then: checar_rep = False: Exit Function
   End If
  Next y
 Next x
 
End Function
'/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////

