Attribute VB_Name = "Gen_Mov"
Option Explicit

'/////////////////////////////////////////////////////////////////////////
'Genera los posibles movimientos de las negras (Mov. uno) ////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub movi_negras1(casilla_p() As Long, ByVal x As Long, ByVal y As Long)
 Select Case casilla_p(x, y)
  Case peon
   If y = siete And casilla_p(x, y - uno) = cero And casilla_p(x, y - dos) = cero Then posibles_n1 x, y - dos, x, y
   If casilla_p(x, y - uno) = cero Then posibles_n1 x, y - uno, x, y
   If casilla_p(x + uno, y - uno) < cero Then posibles_n1 x + uno, y - uno, x, y
   If casilla_p(x - uno, y - uno) < cero Then posibles_n1 x - uno, y - uno, x, y
  Case caballo
   If casilla_p(x + dos, y + uno) <= cero Then posibles_n1 x + dos, y + uno, x, y
   If casilla_p(x + dos, y - uno) <= cero Then posibles_n1 x + dos, y - uno, x, y
   If casilla_p(x - dos, y - uno) <= cero Then posibles_n1 x - dos, y - uno, x, y
   If casilla_p(x - dos, y + uno) <= cero Then posibles_n1 x - dos, y + uno, x, y
   If casilla_p(x + uno, y + dos) <= cero Then posibles_n1 x + uno, y + dos, x, y
   If casilla_p(x - uno, y + dos) <= cero Then posibles_n1 x - uno, y + dos, x, y
   If casilla_p(x + uno, y - dos) <= cero Then posibles_n1 x + uno, y - dos, x, y
   If casilla_p(x - uno, y - dos) <= cero Then posibles_n1 x - uno, y - dos, x, y
  Case alfil
   gen_ne1 x, y, casilla_p(), uno, uno
   gen_ne1 x, y, casilla_p(), uno, -uno
   gen_ne1 x, y, casilla_p(), -uno, uno
   gen_ne1 x, y, casilla_p(), -uno, -uno
  Case torre
   gen_ne1 x, y, casilla_p(), cero, uno
   gen_ne1 x, y, casilla_p(), cero, -uno
   gen_ne1 x, y, casilla_p(), uno, cero
   gen_ne1 x, y, casilla_p(), -uno, cero
  Case reina
   gen_ne1 x, y, casilla_p(), uno, uno
   gen_ne1 x, y, casilla_p(), uno, -uno
   gen_ne1 x, y, casilla_p(), -uno, uno
   gen_ne1 x, y, casilla_p(), -uno, -uno
   gen_ne1 x, y, casilla_p(), cero, uno
   gen_ne1 x, y, casilla_p(), cero, -uno
   gen_ne1 x, y, casilla_p(), uno, cero
   gen_ne1 x, y, casilla_p(), -uno, cero
  Case reyn
   If casilla_p(x + uno, y + uno) <= cero Then posibles_n1 x + uno, y + uno, x, y
   If casilla_p(x - uno, y + uno) <= cero Then posibles_n1 x - uno, y + uno, x, y
   If casilla_p(x - uno, y - uno) <= cero Then posibles_n1 x - uno, y - uno, x, y
   If casilla_p(x + uno, y - uno) <= cero Then posibles_n1 x + uno, y - uno, x, y
   If casilla_p(x, y - uno) <= cero Then posibles_n1 x, y - uno, x, y
   If casilla_p(x, y + uno) <= cero Then posibles_n1 x, y + uno, x, y
   If casilla_p(x - uno, y) <= cero Then posibles_n1 x - uno, y, x, y
   If casilla_p(x + uno, y) <= cero Then posibles_n1 x + uno, y, x, y
  End Select
End Sub

'/////////////////////////////////////////////////////////////////////////
'Genera los posibles movimientos de las blancas (Mov. uno)/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub movi_blancas1(casilla_p() As Long, ByVal x As Long, ByVal y As Long)
 Select Case casilla_p(x, y)
  Case -peon
   If y = dos And casilla_p(x, y + uno) = cero And casilla_p(x, y + dos) = cero Then posibles_b1 x, y + dos, x, y
   If casilla_p(x, y + uno) = cero Then posibles_b1 x, y + uno, x, y
   If casilla_p(x + uno, y + uno) > cero And casilla_p(x + uno, y + uno) <> dos Then posibles_b1 x + uno, y + uno, x, y
   If casilla_p(x - uno, y + uno) > cero And casilla_p(x - uno, y + uno) <> dos Then posibles_b1 x - uno, y + uno, x, y
  Case -caballo
   If casilla_p(x + dos, y + uno) >= cero And casilla_p(x + dos, y + uno) <> dos Then posibles_b1 x + dos, y + uno, x, y
   If casilla_p(x + dos, y - uno) >= cero And casilla_p(x + dos, y - uno) <> dos Then posibles_b1 x + dos, y - uno, x, y
   If casilla_p(x - dos, y - uno) >= cero And casilla_p(x - dos, y - uno) <> dos Then posibles_b1 x - dos, y - uno, x, y
   If casilla_p(x - dos, y + uno) >= cero And casilla_p(x - dos, y + uno) <> dos Then posibles_b1 x - dos, y + uno, x, y
   If casilla_p(x + uno, y + dos) >= cero And casilla_p(x + uno, y + dos) <> dos Then posibles_b1 x + uno, y + dos, x, y
   If casilla_p(x - uno, y + dos) >= cero And casilla_p(x - uno, y + dos) <> dos Then posibles_b1 x - uno, y + dos, x, y
   If casilla_p(x + uno, y - dos) >= cero And casilla_p(x + uno, y - dos) <> dos Then posibles_b1 x + uno, y - dos, x, y
   If casilla_p(x - uno, y - dos) >= cero And casilla_p(x - uno, y - dos) <> dos Then posibles_b1 x - uno, y - dos, x, y
  Case -alfil
   gen_bl1 x, y, casilla_p(), uno, uno
   gen_bl1 x, y, casilla_p(), uno, -uno
   gen_bl1 x, y, casilla_p(), -uno, uno
   gen_bl1 x, y, casilla_p(), -uno, -uno
  Case -torre
   gen_bl1 x, y, casilla_p(), cero, uno
   gen_bl1 x, y, casilla_p(), cero, -uno
   gen_bl1 x, y, casilla_p(), uno, cero
   gen_bl1 x, y, casilla_p(), -uno, cero
  Case -reina
   gen_bl1 x, y, casilla_p(), uno, uno
   gen_bl1 x, y, casilla_p(), uno, -uno
   gen_bl1 x, y, casilla_p(), -uno, uno
   gen_bl1 x, y, casilla_p(), -uno, -uno
   gen_bl1 x, y, casilla_p(), cero, uno
   gen_bl1 x, y, casilla_p(), cero, -uno
   gen_bl1 x, y, casilla_p(), uno, cero
   gen_bl1 x, y, casilla_p(), -uno, cero
  Case -reyb
   If casilla_p(x + uno, y + uno) >= cero And casilla_p(x + uno, y + uno) <> dos Then posibles_b1 x + uno, y + uno, x, y
   If casilla_p(x - uno, y + uno) >= cero And casilla_p(x - uno, y + uno) <> dos Then posibles_b1 x - uno, y + uno, x, y
   If casilla_p(x - uno, y - uno) >= cero And casilla_p(x - uno, y - uno) <> dos Then posibles_b1 x - uno, y - uno, x, y
   If casilla_p(x + uno, y - uno) >= cero And casilla_p(x + uno, y - uno) <> dos Then posibles_b1 x + uno, y - uno, x, y
   If casilla_p(x, y - uno) >= cero And casilla_p(x, y - uno) <> dos Then posibles_b1 x, y - uno, x, y
   If casilla_p(x, y + uno) >= cero And casilla_p(x, y + uno) <> dos Then posibles_b1 x, y + uno, x, y
   If casilla_p(x - uno, y) >= cero And casilla_p(x - uno, y) <> dos Then posibles_b1 x - uno, y, x, y
   If casilla_p(x + uno, y) >= cero And casilla_p(x + uno, y) <> dos Then posibles_b1 x + uno, y, x, y
  End Select
End Sub

'/////////////////////////////////////////////////////////////////////////
'Genera los posibles movimientos de las negras (Mov. dos)
'/////////////////////////////////////////////////////////////////////////
Public Sub movi_negras2(casilla_p() As Long, ByVal x As Long, ByVal y As Long)
 Select Case casilla_p(x, y)
  Case peon
   If y = siete And casilla_p(x, y - uno) = cero And casilla_p(x, y - dos) = cero Then posibles_n2 x, y - dos, x, y
   If casilla_p(x, y - uno) = cero Then posibles_n2 x, y - uno, x, y
   If casilla_p(x + uno, y - uno) < cero Then posibles_n2 x + uno, y - uno, x, y
   If casilla_p(x - uno, y - uno) < cero Then posibles_n2 x - uno, y - uno, x, y
  Case caballo
   If casilla_p(x + dos, y + uno) <= cero Then posibles_n2 x + dos, y + uno, x, y
   If casilla_p(x + dos, y - uno) <= cero Then posibles_n2 x + dos, y - uno, x, y
   If casilla_p(x - dos, y - uno) <= cero Then posibles_n2 x - dos, y - uno, x, y
   If casilla_p(x - dos, y + uno) <= cero Then posibles_n2 x - dos, y + uno, x, y
   If casilla_p(x + uno, y + dos) <= cero Then posibles_n2 x + uno, y + dos, x, y
   If casilla_p(x - uno, y + dos) <= cero Then posibles_n2 x - uno, y + dos, x, y
   If casilla_p(x + uno, y - dos) <= cero Then posibles_n2 x + uno, y - dos, x, y
   If casilla_p(x - uno, y - dos) <= cero Then posibles_n2 x - uno, y - dos, x, y
  Case alfil
   gen_ne2 x, y, casilla_p(), uno, uno
   gen_ne2 x, y, casilla_p(), uno, -uno
   gen_ne2 x, y, casilla_p(), -uno, uno
   gen_ne2 x, y, casilla_p(), -uno, -uno
  Case torre
   gen_ne2 x, y, casilla_p(), cero, uno
   gen_ne2 x, y, casilla_p(), cero, -uno
   gen_ne2 x, y, casilla_p(), uno, cero
   gen_ne2 x, y, casilla_p(), -uno, cero
  Case reina
   gen_ne2 x, y, casilla_p(), uno, uno
   gen_ne2 x, y, casilla_p(), uno, -uno
   gen_ne2 x, y, casilla_p(), -uno, uno
   gen_ne2 x, y, casilla_p(), -uno, -uno
   gen_ne2 x, y, casilla_p(), cero, uno
   gen_ne2 x, y, casilla_p(), cero, -uno
   gen_ne2 x, y, casilla_p(), uno, cero
   gen_ne2 x, y, casilla_p(), -uno, cero
  Case reyn
   If casilla_p(x + uno, y + uno) <= cero Then posibles_n2 x + uno, y + uno, x, y
   If casilla_p(x - uno, y + uno) <= cero Then posibles_n2 x - uno, y + uno, x, y
   If casilla_p(x - uno, y - uno) <= cero Then posibles_n2 x - uno, y - uno, x, y
   If casilla_p(x + uno, y - uno) <= cero Then posibles_n2 x + uno, y - uno, x, y
   If casilla_p(x, y - uno) <= cero Then posibles_n2 x, y - uno, x, y
   If casilla_p(x, y + uno) <= cero Then posibles_n2 x, y + uno, x, y
   If casilla_p(x - uno, y) <= cero Then posibles_n2 x - uno, y, x, y
   If casilla_p(x + uno, y) <= cero Then posibles_n2 x + uno, y, x, y
  End Select
End Sub

'/////////////////////////////////////////////////////////////////////////
'Genera los posibles movimientos de las blancas  (Mov. dos)/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub movi_blancas2(casilla_p() As Long, ByVal x As Long, ByVal y As Long)
 Select Case casilla_p(x, y)
  Case -peon
   If y = dos And casilla_p(x, y + uno) = cero And casilla_p(x, y + dos) = cero Then posibles_b2 x, y + dos, x, y
   If casilla_p(x, y + uno) = cero Then posibles_b2 x, y + uno, x, y
   If casilla_p(x + uno, y + uno) > cero And casilla_p(x + uno, y + uno) <> dos Then posibles_b2 x + uno, y + uno, x, y
   If casilla_p(x - uno, y + uno) > cero And casilla_p(x - uno, y + uno) <> dos Then posibles_b2 x - uno, y + uno, x, y
  Case -caballo
   If casilla_p(x + dos, y + uno) >= cero And casilla_p(x + dos, y + uno) <> dos Then posibles_b2 x + dos, y + uno, x, y
   If casilla_p(x + dos, y - uno) >= cero And casilla_p(x + dos, y - uno) <> dos Then posibles_b2 x + dos, y - uno, x, y
   If casilla_p(x - dos, y - uno) >= cero And casilla_p(x - dos, y - uno) <> dos Then posibles_b2 x - dos, y - uno, x, y
   If casilla_p(x - dos, y + uno) >= cero And casilla_p(x - dos, y + uno) <> dos Then posibles_b2 x - dos, y + uno, x, y
   If casilla_p(x + uno, y + dos) >= cero And casilla_p(x + uno, y + dos) <> dos Then posibles_b2 x + uno, y + dos, x, y
   If casilla_p(x - uno, y + dos) >= cero And casilla_p(x - uno, y + dos) <> dos Then posibles_b2 x - uno, y + dos, x, y
   If casilla_p(x + uno, y - dos) >= cero And casilla_p(x + uno, y - dos) <> dos Then posibles_b2 x + uno, y - dos, x, y
   If casilla_p(x - uno, y - dos) >= cero And casilla_p(x - uno, y - dos) <> dos Then posibles_b2 x - uno, y - dos, x, y
  Case -alfil
   gen_bl2 x, y, casilla_p(), uno, uno
   gen_bl2 x, y, casilla_p(), uno, -uno
   gen_bl2 x, y, casilla_p(), -uno, uno
   gen_bl2 x, y, casilla_p(), -uno, -uno
  Case -torre
   gen_bl2 x, y, casilla_p(), cero, uno
   gen_bl2 x, y, casilla_p(), cero, -uno
   gen_bl2 x, y, casilla_p(), uno, cero
   gen_bl2 x, y, casilla_p(), -uno, cero
  Case -reina
   gen_bl2 x, y, casilla_p(), uno, uno
   gen_bl2 x, y, casilla_p(), uno, -uno
   gen_bl2 x, y, casilla_p(), -uno, uno
   gen_bl2 x, y, casilla_p(), -uno, -uno
   gen_bl2 x, y, casilla_p(), cero, uno
   gen_bl2 x, y, casilla_p(), cero, -uno
   gen_bl2 x, y, casilla_p(), uno, cero
   gen_bl2 x, y, casilla_p(), -uno, cero
  Case -reyb
   If casilla_p(x + uno, y + uno) >= cero And casilla_p(x + uno, y + uno) <> dos Then posibles_b2 x + uno, y + uno, x, y
   If casilla_p(x - uno, y + uno) >= cero And casilla_p(x - uno, y + uno) <> dos Then posibles_b2 x - uno, y + uno, x, y
   If casilla_p(x - uno, y - uno) >= cero And casilla_p(x - uno, y - uno) <> dos Then posibles_b2 x - uno, y - uno, x, y
   If casilla_p(x + uno, y - uno) >= cero And casilla_p(x + uno, y - uno) <> dos Then posibles_b2 x + uno, y - uno, x, y
   If casilla_p(x, y - uno) >= cero And casilla_p(x, y - uno) <> dos Then posibles_b2 x, y - uno, x, y
   If casilla_p(x, y + uno) >= cero And casilla_p(x, y + uno) <> dos Then posibles_b2 x, y + uno, x, y
   If casilla_p(x - uno, y) >= cero And casilla_p(x - uno, y) <> dos Then posibles_b2 x - uno, y, x, y
   If casilla_p(x + uno, y) >= cero And casilla_p(x + uno, y) <> dos Then posibles_b2 x + uno, y, x, y
  End Select
End Sub

'/////////////////////////////////////////////////////////////////////////
'Genera los posibles movimientos de las negras (Mov. tres)
'/////////////////////////////////////////////////////////////////////////
Public Sub movi_negras3(casilla_p() As Long, ByVal x As Long, ByVal y As Long)
 Select Case casilla_p(x, y)
  Case peon
   If y = siete And casilla_p(x, y - uno) = cero And casilla_p(x, y - dos) = cero Then posibles_n3 x, y - dos, x, y
   If casilla_p(x, y - uno) = cero Then posibles_n3 x, y - uno, x, y
   If casilla_p(x + uno, y - uno) < cero Then posibles_n3 x + uno, y - uno, x, y
   If casilla_p(x - uno, y - uno) < cero Then posibles_n3 x - uno, y - uno, x, y
  Case caballo
   If casilla_p(x + dos, y + uno) <= cero Then posibles_n3 x + dos, y + uno, x, y
   If casilla_p(x + dos, y - uno) <= cero Then posibles_n3 x + dos, y - uno, x, y
   If casilla_p(x - dos, y - uno) <= cero Then posibles_n3 x - dos, y - uno, x, y
   If casilla_p(x - dos, y + uno) <= cero Then posibles_n3 x - dos, y + uno, x, y
   If casilla_p(x + uno, y + dos) <= cero Then posibles_n3 x + uno, y + dos, x, y
   If casilla_p(x - uno, y + dos) <= cero Then posibles_n3 x - uno, y + dos, x, y
   If casilla_p(x + uno, y - dos) <= cero Then posibles_n3 x + uno, y - dos, x, y
   If casilla_p(x - uno, y - dos) <= cero Then posibles_n3 x - uno, y - dos, x, y
  Case alfil
   gen_ne3 x, y, casilla_p(), uno, uno
   gen_ne3 x, y, casilla_p(), uno, -uno
   gen_ne3 x, y, casilla_p(), -uno, uno
   gen_ne3 x, y, casilla_p(), -uno, -uno
  Case torre
   gen_ne3 x, y, casilla_p(), cero, uno
   gen_ne3 x, y, casilla_p(), cero, -uno
   gen_ne3 x, y, casilla_p(), uno, cero
   gen_ne3 x, y, casilla_p(), -uno, cero
  Case reina
   gen_ne3 x, y, casilla_p(), uno, uno
   gen_ne3 x, y, casilla_p(), uno, -uno
   gen_ne3 x, y, casilla_p(), -uno, uno
   gen_ne3 x, y, casilla_p(), -uno, -uno
   gen_ne3 x, y, casilla_p(), cero, uno
   gen_ne3 x, y, casilla_p(), cero, -uno
   gen_ne3 x, y, casilla_p(), uno, cero
   gen_ne3 x, y, casilla_p(), -uno, cero
  Case reyn
   If casilla_p(x + uno, y + uno) <= cero Then posibles_n3 x + uno, y + uno, x, y
   If casilla_p(x - uno, y + uno) <= cero Then posibles_n3 x - uno, y + uno, x, y
   If casilla_p(x - uno, y - uno) <= cero Then posibles_n3 x - uno, y - uno, x, y
   If casilla_p(x + uno, y - uno) <= cero Then posibles_n3 x + uno, y - uno, x, y
   If casilla_p(x, y - uno) <= cero Then posibles_n3 x, y - uno, x, y
   If casilla_p(x, y + uno) <= cero Then posibles_n3 x, y + uno, x, y
   If casilla_p(x - uno, y) <= cero Then posibles_n3 x - uno, y, x, y
   If casilla_p(x + uno, y) <= cero Then posibles_n3 x + uno, y, x, y
  End Select
End Sub

'/////////////////////////////////////////////////////////////////////////
'Genera los posibles movimientos de las blancas (Mov. tres)/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub movi_blancas3(casilla_p() As Long, ByVal x As Long, ByVal y As Long)
 Select Case casilla_p(x, y)
  Case -peon
   If y = dos And casilla_p(x, y + uno) = cero And casilla_p(x, y + dos) = cero Then posibles_b3 x, y + dos, x, y
   If casilla_p(x, y + uno) = cero Then posibles_b3 x, y + uno, x, y
   If casilla_p(x + uno, y + uno) > cero And casilla_p(x + uno, y + uno) <> dos Then posibles_b3 x + uno, y + uno, x, y
   If casilla_p(x - uno, y + uno) > cero And casilla_p(x - uno, y + uno) <> dos Then posibles_b3 x - uno, y + uno, x, y
  Case -caballo
   If casilla_p(x + dos, y + uno) >= cero And casilla_p(x + dos, y + uno) <> dos Then posibles_b3 x + dos, y + uno, x, y
   If casilla_p(x + dos, y - uno) >= cero And casilla_p(x + dos, y - uno) <> dos Then posibles_b3 x + dos, y - uno, x, y
   If casilla_p(x - dos, y - uno) >= cero And casilla_p(x - dos, y - uno) <> dos Then posibles_b3 x - dos, y - uno, x, y
   If casilla_p(x - dos, y + uno) >= cero And casilla_p(x - dos, y + uno) <> dos Then posibles_b3 x - dos, y + uno, x, y
   If casilla_p(x + uno, y + dos) >= cero And casilla_p(x + uno, y + dos) <> dos Then posibles_b3 x + uno, y + dos, x, y
   If casilla_p(x - uno, y + dos) >= cero And casilla_p(x - uno, y + dos) <> dos Then posibles_b3 x - uno, y + dos, x, y
   If casilla_p(x + uno, y - dos) >= cero And casilla_p(x + uno, y - dos) <> dos Then posibles_b3 x + uno, y - dos, x, y
   If casilla_p(x - uno, y - dos) >= cero And casilla_p(x - uno, y - dos) <> dos Then posibles_b3 x - uno, y - dos, x, y
  Case -alfil
   gen_bl3 x, y, casilla_p(), uno, uno
   gen_bl3 x, y, casilla_p(), uno, -uno
   gen_bl3 x, y, casilla_p(), -uno, uno
   gen_bl3 x, y, casilla_p(), -uno, -uno
  Case -torre
   gen_bl3 x, y, casilla_p(), cero, uno
   gen_bl3 x, y, casilla_p(), cero, -uno
   gen_bl3 x, y, casilla_p(), uno, cero
   gen_bl3 x, y, casilla_p(), -uno, cero
  Case -reina
   gen_bl3 x, y, casilla_p(), uno, uno
   gen_bl3 x, y, casilla_p(), uno, -uno
   gen_bl3 x, y, casilla_p(), -uno, uno
   gen_bl3 x, y, casilla_p(), -uno, -uno
   gen_bl3 x, y, casilla_p(), cero, uno
   gen_bl3 x, y, casilla_p(), cero, -uno
   gen_bl3 x, y, casilla_p(), uno, cero
   gen_bl3 x, y, casilla_p(), -uno, cero
  Case -reyb
   If casilla_p(x + uno, y + uno) >= cero And casilla_p(x + uno, y + uno) <> dos Then posibles_b3 x + uno, y + uno, x, y
   If casilla_p(x - uno, y + uno) >= cero And casilla_p(x - uno, y + uno) <> dos Then posibles_b3 x - uno, y + uno, x, y
   If casilla_p(x - uno, y - uno) >= cero And casilla_p(x - uno, y - uno) <> dos Then posibles_b3 x - uno, y - uno, x, y
   If casilla_p(x + uno, y - uno) >= cero And casilla_p(x + uno, y - uno) <> dos Then posibles_b3 x + uno, y - uno, x, y
   If casilla_p(x, y - uno) >= cero And casilla_p(x, y - uno) <> dos Then posibles_b3 x, y - uno, x, y
   If casilla_p(x, y + uno) >= cero And casilla_p(x, y + uno) <> dos Then posibles_b3 x, y + uno, x, y
   If casilla_p(x - uno, y) >= cero And casilla_p(x - uno, y) <> dos Then posibles_b3 x - uno, y, x, y
   If casilla_p(x + uno, y) >= cero And casilla_p(x + uno, y) <> dos Then posibles_b3 x + uno, y, x, y
  End Select
End Sub

'/////////////////////////////////////////////////////////////////////////
'Genera los posibles movimientos de las negras (Para operaciones secundarias)
'/////////////////////////////////////////////////////////////////////////
Public Sub movi_negras4(casilla_p() As Long, ByVal x As Long, ByVal y As Long)
 Select Case casilla_p(x, y)
  Case peon
   If y = siete And casilla_p(x, y - uno) = cero And casilla_p(x, y - dos) = cero Then posibles_n4 x, y - dos, x, y
   If casilla_p(x, y - uno) = cero Then posibles_n4 x, y - uno, x, y
   If casilla_p(x + uno, y - uno) < cero Then posibles_n4 x + uno, y - uno, x, y
   If casilla_p(x - uno, y - uno) < cero Then posibles_n4 x - uno, y - uno, x, y
  Case caballo
   If casilla_p(x + dos, y + uno) <= cero Then posibles_n4 x + dos, y + uno, x, y
   If casilla_p(x + dos, y - uno) <= cero Then posibles_n4 x + dos, y - uno, x, y
   If casilla_p(x - dos, y - uno) <= cero Then posibles_n4 x - dos, y - uno, x, y
   If casilla_p(x - dos, y + uno) <= cero Then posibles_n4 x - dos, y + uno, x, y
   If casilla_p(x + uno, y + dos) <= cero Then posibles_n4 x + uno, y + dos, x, y
   If casilla_p(x - uno, y + dos) <= cero Then posibles_n4 x - uno, y + dos, x, y
   If casilla_p(x + uno, y - dos) <= cero Then posibles_n4 x + uno, y - dos, x, y
   If casilla_p(x - uno, y - dos) <= cero Then posibles_n4 x - uno, y - dos, x, y
  Case alfil
   gen_ne4 x, y, casilla_p(), uno, uno
   gen_ne4 x, y, casilla_p(), uno, -uno
   gen_ne4 x, y, casilla_p(), -uno, uno
   gen_ne4 x, y, casilla_p(), -uno, -uno
  Case torre
   gen_ne4 x, y, casilla_p(), cero, uno
   gen_ne4 x, y, casilla_p(), cero, -uno
   gen_ne4 x, y, casilla_p(), uno, cero
   gen_ne4 x, y, casilla_p(), -uno, cero
  Case reina
   gen_ne4 x, y, casilla_p(), uno, uno
   gen_ne4 x, y, casilla_p(), uno, -uno
   gen_ne4 x, y, casilla_p(), -uno, uno
   gen_ne4 x, y, casilla_p(), -uno, -uno
   gen_ne4 x, y, casilla_p(), cero, uno
   gen_ne4 x, y, casilla_p(), cero, -uno
   gen_ne4 x, y, casilla_p(), uno, cero
   gen_ne4 x, y, casilla_p(), -uno, cero
  Case reyn
   If casilla_p(x + uno, y + uno) <= cero Then posibles_n4 x + uno, y + uno, x, y
   If casilla_p(x - uno, y + uno) <= cero Then posibles_n4 x - uno, y + uno, x, y
   If casilla_p(x - uno, y - uno) <= cero Then posibles_n4 x - uno, y - uno, x, y
   If casilla_p(x + uno, y - uno) <= cero Then posibles_n4 x + uno, y - uno, x, y
   If casilla_p(x, y - uno) <= cero Then posibles_n4 x, y - uno, x, y
   If casilla_p(x, y + uno) <= cero Then posibles_n4 x, y + uno, x, y
   If casilla_p(x - uno, y) <= cero Then posibles_n4 x - uno, y, x, y
   If casilla_p(x + uno, y) <= cero Then posibles_n4 x + uno, y, x, y
  End Select
End Sub

'/////////////////////////////////////////////////////////////////////////
'Genera los posibles movimientos de las blancas (Para operaciones secundarias) /////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub movi_blancas4(casilla_p() As Long, ByVal x As Long, ByVal y As Long)
 Select Case casilla_p(x, y)
  Case -peon
   If y = dos And casilla_p(x, y + uno) = cero And casilla_p(x, y + dos) = cero Then posibles_b4 x, y + dos, x, y
   If casilla_p(x, y + uno) = cero Then posibles_b4 x, y + uno, x, y
   If casilla_p(x + uno, y + uno) > cero And casilla_p(x + uno, y + uno) <> dos Then posibles_b4 x + uno, y + uno, x, y
   If casilla_p(x - uno, y + uno) > cero And casilla_p(x - uno, y + uno) <> dos Then posibles_b4 x - uno, y + uno, x, y
  Case -caballo
   If casilla_p(x + dos, y + uno) >= cero And casilla_p(x + dos, y + uno) <> dos Then posibles_b4 x + dos, y + uno, x, y
   If casilla_p(x + dos, y - uno) >= cero And casilla_p(x + dos, y - uno) <> dos Then posibles_b4 x + dos, y - uno, x, y
   If casilla_p(x - dos, y - uno) >= cero And casilla_p(x - dos, y - uno) <> dos Then posibles_b4 x - dos, y - uno, x, y
   If casilla_p(x - dos, y + uno) >= cero And casilla_p(x - dos, y + uno) <> dos Then posibles_b4 x - dos, y + uno, x, y
   If casilla_p(x + uno, y + dos) >= cero And casilla_p(x + uno, y + dos) <> dos Then posibles_b4 x + uno, y + dos, x, y
   If casilla_p(x - uno, y + dos) >= cero And casilla_p(x - uno, y + dos) <> dos Then posibles_b4 x - uno, y + dos, x, y
   If casilla_p(x + uno, y - dos) >= cero And casilla_p(x + uno, y - dos) <> dos Then posibles_b4 x + uno, y - dos, x, y
   If casilla_p(x - uno, y - dos) >= cero And casilla_p(x - uno, y - dos) <> dos Then posibles_b4 x - uno, y - dos, x, y
  Case -alfil
   gen_bl4 x, y, casilla_p(), uno, uno
   gen_bl4 x, y, casilla_p(), uno, -uno
   gen_bl4 x, y, casilla_p(), -uno, uno
   gen_bl4 x, y, casilla_p(), -uno, -uno
  Case -torre
   gen_bl4 x, y, casilla_p(), cero, uno
   gen_bl4 x, y, casilla_p(), cero, -uno
   gen_bl4 x, y, casilla_p(), uno, cero
   gen_bl4 x, y, casilla_p(), -uno, cero
  Case -reina
   gen_bl4 x, y, casilla_p(), uno, uno
   gen_bl4 x, y, casilla_p(), uno, -uno
   gen_bl4 x, y, casilla_p(), -uno, uno
   gen_bl4 x, y, casilla_p(), -uno, -uno
   gen_bl4 x, y, casilla_p(), cero, uno
   gen_bl4 x, y, casilla_p(), cero, -uno
   gen_bl4 x, y, casilla_p(), uno, cero
   gen_bl4 x, y, casilla_p(), -uno, cero
  Case -reyb
   If casilla_p(x + uno, y + uno) >= cero And casilla_p(x + uno, y + uno) <> dos Then posibles_b4 x + uno, y + uno, x, y
   If casilla_p(x - uno, y + uno) >= cero And casilla_p(x - uno, y + uno) <> dos Then posibles_b4 x - uno, y + uno, x, y
   If casilla_p(x - uno, y - uno) >= cero And casilla_p(x - uno, y - uno) <> dos Then posibles_b4 x - uno, y - uno, x, y
   If casilla_p(x + uno, y - uno) >= cero And casilla_p(x + uno, y - uno) <> dos Then posibles_b4 x + uno, y - uno, x, y
   If casilla_p(x, y - uno) >= cero And casilla_p(x, y - uno) <> dos Then posibles_b4 x, y - uno, x, y
   If casilla_p(x, y + uno) >= cero And casilla_p(x, y + uno) <> dos Then posibles_b4 x, y + uno, x, y
   If casilla_p(x - uno, y) >= cero And casilla_p(x - uno, y) <> dos Then posibles_b4 x - uno, y, x, y
   If casilla_p(x + uno, y) >= cero And casilla_p(x + uno, y) <> dos Then posibles_b4 x + uno, y, x, y
  End Select
End Sub

'/////////////////////////////////////////////////////////////////////////
'Genera los movimientos secuenciales (ejemplo=reina, alfil,torre)/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub gen_bl1(x As Long, y As Long, casilla_p() As Long, mx As Long, my As Long): Dim cx As Long, cy As Long
 cx = cero
 cx = cx + mx
 cy = cero
 cy = cy + my
 Do Until (casilla_p(x + cx, y + cy) = dos)
  Select Case casilla_p(x + cx, y + cy)
   Case Is > cero: posibles_b1 x + cx, y + cy, x, y: Exit Do
   Case Is = cero: posibles_b1 x + cx, y + cy, x, y
   Case Is < cero: Exit Do
  End Select
  cx = cx + mx
  cy = cy + my
 Loop
End Sub

'/////////////////////////////////////////////////////////////////////////
'Genera los movimientos secuenciales (ejemplo=reina, alfil,torre)/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub gen_ne1(x As Long, y As Long, casilla_p() As Long, mx As Long, my As Long): Dim cx As Long, cy As Long
 cx = cero
 cx = cx + mx
 cy = cero
 cy = cy + my
 Do Until (casilla_p(x + cx, y + cy) = dos)
  Select Case casilla_p(x + cx, y + cy)
   Case Is < cero: posibles_n1 x + cx, y + cy, x, y: Exit Do
   Case Is = cero: posibles_n1 x + cx, y + cy, x, y
   Case Is > cero: Exit Do
  End Select
  cx = cx + mx
  cy = cy + my
 Loop
End Sub

'/////////////////////////////////////////////////////////////////////////
'Genera los movimientos secuenciales (ejemplo=reina, alfil,torre)/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub gen_bl2(x As Long, y As Long, casilla_p() As Long, mx As Long, my As Long): Dim cx As Long, cy As Long
 cx = cero
 cx = cx + mx
 cy = cero
 cy = cy + my
 Do Until (casilla_p(x + cx, y + cy) = dos)
  Select Case casilla_p(x + cx, y + cy)
   Case Is > cero: posibles_b2 x + cx, y + cy, x, y: Exit Do
   Case Is = cero: posibles_b2 x + cx, y + cy, x, y
   Case Is < cero: Exit Do
  End Select
  cx = cx + mx
  cy = cy + my
 Loop
End Sub

'/////////////////////////////////////////////////////////////////////////
'Genera los movimientos secuenciales (ejemplo=reina, alfil,torre)/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub gen_ne2(x As Long, y As Long, casilla_p() As Long, mx As Long, my As Long): Dim cx As Long, cy As Long
 cx = cero
 cx = cx + mx
 cy = cero
 cy = cy + my
 Do Until (casilla_p(x + cx, y + cy) = dos)
  Select Case casilla_p(x + cx, y + cy)
   Case Is < cero: posibles_n2 x + cx, y + cy, x, y: Exit Do
   Case Is = cero: posibles_n2 x + cx, y + cy, x, y
   Case Is > cero: Exit Do
  End Select
  cx = cx + mx
  cy = cy + my
 Loop
End Sub

'/////////////////////////////////////////////////////////////////////////
'Genera los movimientos secuenciales (ejemplo=reina, alfil,torre)/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub gen_bl3(x As Long, y As Long, casilla_p() As Long, mx As Long, my As Long): Dim cx As Long, cy As Long
 cx = cero
 cx = cx + mx
 cy = cero
 cy = cy + my
 Do Until (casilla_p(x + cx, y + cy) = dos)
  Select Case casilla_p(x + cx, y + cy)
   Case Is > cero: posibles_b3 x + cx, y + cy, x, y: Exit Do
   Case Is = cero: posibles_b3 x + cx, y + cy, x, y
   Case Is < cero: Exit Do
  End Select
  cx = cx + mx
  cy = cy + my
 Loop
End Sub

'/////////////////////////////////////////////////////////////////////////
'Genera los movimientos secuenciales (ejemplo=reina, alfil,torre)/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub gen_ne3(x As Long, y As Long, casilla_p() As Long, mx As Long, my As Long): Dim cx As Long, cy As Long
 cx = cero
 cx = cx + mx
 cy = cero
 cy = cy + my
 Do Until (casilla_p(x + cx, y + cy) = dos)
  Select Case casilla_p(x + cx, y + cy)
   Case Is < cero: posibles_n3 x + cx, y + cy, x, y: Exit Do
   Case Is = cero: posibles_n3 x + cx, y + cy, x, y
   Case Is > cero: Exit Do
  End Select
  cx = cx + mx
  cy = cy + my
 Loop
End Sub

'/////////////////////////////////////////////////////////////////////////
'Genera los movimientos secuenciales (ejemplo=reina, alfil,torre)/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub gen_bl4(x As Long, y As Long, casilla_p() As Long, mx As Long, my As Long): Dim cx As Long, cy As Long
 cx = cero
 cx = cx + mx
 cy = cero
 cy = cy + my
 Do Until (casilla_p(x + cx, y + cy) = dos)
  Select Case casilla_p(x + cx, y + cy)
   Case Is > cero: posibles_b4 x + cx, y + cy, x, y: Exit Do
   Case Is = cero: posibles_b4 x + cx, y + cy, x, y
   Case Is < cero: Exit Do
  End Select
  cx = cx + mx
  cy = cy + my
 Loop
End Sub

'/////////////////////////////////////////////////////////////////////////
'Genera los movimientos secuenciales (ejemplo=reina, alfil,torre)/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub gen_ne4(x As Long, y As Long, casilla_p() As Long, mx As Long, my As Long): Dim cx As Long, cy As Long
 cx = cero
 cx = cx + mx
 cy = cero
 cy = cy + my
 Do Until (casilla_p(x + cx, y + cy) = dos)
  Select Case casilla_p(x + cx, y + cy)
   Case Is < cero: posibles_n4 x + cx, y + cy, x, y: Exit Do
   Case Is = cero: posibles_n4 x + cx, y + cy, x, y
   Case Is > cero: Exit Do
  End Select
  cx = cx + mx
  cy = cy + my
 Loop
End Sub

'/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////


















