Attribute VB_Name = "Gen_mov2"
'/////////////////////////////////////////////////////////////////////////
'Genera los posibles movimientos de las negras
'/////////////////////////////////////////////////////////////////////////
Private Sub movi_negras(casilla_p() As Long, ByVal x As Long, ByVal y As Long)
 
 Select Case casilla_p(x, y)
  Case peon
   If y = siete And casilla_p(x, y - uno) = cero And casilla_p(x, y - dos) = cero Then posibles_n x, y - dos, x, y
   If casilla_p(x, y - uno) = cero Then posibles_n x, y - uno, x, y
   If casilla_p(x + uno, y - uno) < cero Then posibles_n x + uno, y - uno, x, y
   If casilla_p(x - uno, y - uno) < cero Then posibles_n x - uno, y - uno, x, y
  Case caballo
   If casilla_p(x + dos, y + uno) <= cero Then posibles_n x + dos, y + uno, x, y
   If casilla_p(x + dos, y - uno) <= cero Then posibles_n x + dos, y - uno, x, y
   If casilla_p(x - dos, y - uno) <= cero Then posibles_n x - dos, y - uno, x, y
   If casilla_p(x - dos, y + uno) <= cero Then posibles_n x - dos, y + uno, x, y
   If casilla_p(x + uno, y + dos) <= cero Then posibles_n x + uno, y + dos, x, y
   If casilla_p(x - uno, y + dos) <= cero Then posibles_n x - uno, y + dos, x, y
   If casilla_p(x + uno, y - dos) <= cero Then posibles_n x + uno, y - dos, x, y
   If casilla_p(x - uno, y - dos) <= cero Then posibles_n x - uno, y - dos, x, y
  Case alfil
   gen_ne x, y, casilla_p(), uno, uno
   gen_ne x, y, casilla_p(), uno, -uno
   gen_ne x, y, casilla_p(), -uno, uno
   gen_ne x, y, casilla_p(), -uno, -uno
  Case torre
   gen_ne x, y, casilla_p(), cero, uno
   gen_ne x, y, casilla_p(), cero, -uno
   gen_ne x, y, casilla_p(), uno, cero
   gen_ne x, y, casilla_p(), -uno, cero
  Case reina
   gen_ne x, y, casilla_p(), uno, uno
   gen_ne x, y, casilla_p(), uno, -uno
   gen_ne x, y, casilla_p(), -uno, uno
   gen_ne x, y, casilla_p(), -uno, -uno
   gen_ne x, y, casilla_p(), cero, uno
   gen_ne x, y, casilla_p(), cero, -uno
   gen_ne x, y, casilla_p(), uno, cero
   gen_ne x, y, casilla_p(), -uno, cero
  Case reyn
   If casilla_p(x + uno, y + uno) <= cero Then posibles_n x + uno, y + uno, x, y
   If casilla_p(x - uno, y + uno) <= cero Then posibles_n x - uno, y + uno, x, y
   If casilla_p(x - uno, y - uno) <= cero Then posibles_n x - uno, y - uno, x, y
   If casilla_p(x + uno, y - uno) <= cero Then posibles_n x + uno, y - uno, x, y
   If casilla_p(x, y - uno) <= cero Then posibles_n x, y - uno, x, y
   If casilla_p(x, y + uno) <= cero Then posibles_n x, y + uno, x, y
   If casilla_p(x - uno, y) <= cero Then posibles_n x - uno, y, x, y
   If casilla_p(x + uno, y) <= cero Then posibles_n x + uno, y, x, y
  End Select

End Sub

'/////////////////////////////////////////////////////////////////////////
'Genera los posibles movimientos de las blancas
'/////////////////////////////////////////////////////////////////////////
Private Sub movi_blancas(casilla_p() As Long, ByVal x As Long, ByVal y As Long)
 
 Select Case casilla_p(x, y)
  Case -peon
   If y = dos And casilla_p(x, y + uno) = cero And casilla_p(x, y + dos) = cero Then posibles_b x, y + dos, x, y
   If casilla_p(x, y + uno) = cero Then posibles_b x, y + uno, x, y
   If casilla_p(x + uno, y + uno) > cero And casilla_p(x + uno, y + uno) <> dos Then posibles_b x + uno, y + uno, x, y
   If casilla_p(x - uno, y + uno) > cero And casilla_p(x - uno, y + uno) <> dos Then posibles_b x - uno, y + uno, x, y
  Case -caballo
   If casilla_p(x + dos, y + uno) >= cero And casilla_p(x + dos, y + uno) <> dos Then posibles_b x + dos, y + uno, x, y
   If casilla_p(x + dos, y - uno) >= cero And casilla_p(x + dos, y - uno) <> dos Then posibles_b x + dos, y - uno, x, y
   If casilla_p(x - dos, y - uno) >= cero And casilla_p(x - dos, y - uno) <> dos Then posibles_b x - dos, y - uno, x, y
   If casilla_p(x - dos, y + uno) >= cero And casilla_p(x - dos, y + uno) <> dos Then posibles_b x - dos, y + uno, x, y
   If casilla_p(x + uno, y + dos) >= cero And casilla_p(x + uno, y + dos) <> dos Then posibles_b x + uno, y + dos, x, y
   If casilla_p(x - uno, y + dos) >= cero And casilla_p(x - uno, y + dos) <> dos Then posibles_b x - uno, y + dos, x, y
   If casilla_p(x + uno, y - dos) >= cero And casilla_p(x + uno, y - dos) <> dos Then posibles_b x + uno, y - dos, x, y
   If casilla_p(x - uno, y - dos) >= cero And casilla_p(x - uno, y - dos) <> dos Then posibles_b x - uno, y - dos, x, y
  Case -alfil
   gen_bl x, y, casilla_p(), uno, uno
   gen_bl x, y, casilla_p(), uno, -uno
   gen_bl x, y, casilla_p(), -uno, uno
   gen_bl x, y, casilla_p(), -uno, -uno
  Case -torre
   gen_bl x, y, casilla_p(), cero, uno
   gen_bl x, y, casilla_p(), cero, -uno
   gen_bl x, y, casilla_p(), uno, cero
   gen_bl x, y, casilla_p(), -uno, cero
  Case -reina
   gen_bl x, y, casilla_p(), uno, uno
   gen_bl x, y, casilla_p(), uno, -uno
   gen_bl x, y, casilla_p(), -uno, uno
   gen_bl x, y, casilla_p(), -uno, -uno
   gen_bl x, y, casilla_p(), cero, uno
   gen_bl x, y, casilla_p(), cero, -uno
   gen_bl x, y, casilla_p(), uno, cero
   gen_bl x, y, casilla_p(), -uno, cero
  Case -reyb
   If casilla_p(x + uno, y + uno) >= cero And casilla_p(x + uno, y + uno) <> dos Then posibles_b x + uno, y + uno, x, y
   If casilla_p(x - uno, y + uno) >= cero And casilla_p(x - uno, y + uno) <> dos Then posibles_b x - uno, y + uno, x, y
   If casilla_p(x - uno, y - uno) >= cero And casilla_p(x - uno, y - uno) <> dos Then posibles_b x - uno, y - uno, x, y
   If casilla_p(x + uno, y - uno) >= cero And casilla_p(x + uno, y - uno) <> dos Then posibles_b x + uno, y - uno, x, y
   If casilla_p(x, y - uno) >= cero And casilla_p(x, y - uno) <> dos Then posibles_b x, y - uno, x, y
   If casilla_p(x, y + uno) >= cero And casilla_p(x, y + uno) <> dos Then posibles_b x, y + uno, x, y
   If casilla_p(x - uno, y) >= cero And casilla_p(x - uno, y) <> dos Then posibles_b x - uno, y, x, y
   If casilla_p(x + uno, y) >= cero And casilla_p(x + uno, y) <> dos Then posibles_b x + uno, y, x, y
  End Select

End Sub
Private Sub gen_bl(x As Long, y As Long, casilla_p() As Long, mx As Long, my As Long): Dim cx As Long, cy As Long
 
 cx = cero
 cx = cx + mx
 cy = cero
 cy = cy + my
 
 Do Until (casilla_p(x + cx, y + cy) = dos)
  Select Case casilla_p(x + cx, y + cy)
   Case Is > cero: posibles_b x + cx, y + cy, x, y: Exit Do
   Case Is = cero: posibles_b x + cx, y + cy, x, y
   Case Is < cero: Exit Do
  End Select
  cx = cx + mx
  cy = cy + my
 Loop

End Sub
Private Sub gen_ne(x As Long, y As Long, casilla_p() As Long, mx As Long, my As Long): Dim cx As Long, cy As Long
 
 cx = cero
 cx = cx + mx
 cy = cero
 cy = cy + my
 
 Do Until (casilla_p(x + cx, y + cy) = dos)
  Select Case casilla_p(x + cx, y + cy)
   Case Is < cero: posibles_n x + cx, y + cy, x, y: Exit Do
   Case Is = cero: posibles_n x + cx, y + cy, x, y
   Case Is > cero: Exit Do
  End Select
  cx = cx + mx
  cy = cy + my
 Loop

End Sub
