Attribute VB_Name = "busqueda"
Option Explicit

'/////////////////////////////////////////////////////////////////////////
'Inicializa y termina la busqueda de jugadas, llama al primer paso de las negras /////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub buscar(): Dim x As Long, y As Long
 valor_ini = cero
 tablero.Progreso.Value = cero
 calcular_rey casilla()
 evaluar_material casilla()
 tiempo = Timer
 
 For y = uno To ocho
  For x = uno To ocho
   valor_ini = valor_ini + casilla(x, y)
  Next x
 Next y
 
 aviso = False
 cont_n1 = cero
 max1 = -infinito
 
 For y = ocho To uno Step -uno
  For x = uno To ocho
   If casilla(x, y) > cero Then movi_negras1 casilla(), x, y
  Next x
 Next y
 
 enrroque_n
 tablero.Progreso.Max = cont_n1
 ordenamiento
 primeras_n
 
 If max1 < 0 Then ultimo_recurso
 copiar casilla(), casilla_me()
 tablero.Progreso.Value = cero
 tablero.pintar_tablero
 guardar_jugada
 
 ti_co = Int((Timer - tiempo) + ti_co)
 tablero.tiempoco.Caption = ti_co
 Beep
 
End Sub

'/////////////////////////////////////////////////////////////////////////
'Con las negras ordenadas llama al primer paso de las blancas/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub primeras_n(): Dim x As Long, y As Long, a As Long, rep As Boolean
 
 For a = uno To cont_n1
  
  For y = uno To ocho
   For x = uno To ocho
    casilla_n1(x, y) = n1(a, x, y)
   Next x
  Next y
  
  min1 = infinito
  cont_b1 = cero
 
  For y = uno To ocho
   For x = uno To ocho
    If casilla_n1(x, y) < cero Then movi_blancas1 casilla_n1(), x, y
   Next x
  Next y
  
  tablero.Progreso.Value = a
  ordenamiento2
  primeras_b
  
  If min1 > max1 Then
   rep = checar_rep(casilla_n1())
   If rep = False Then
    max1 = min1
    copiar casilla_me(), casilla_n1()
    If max1 > valor_ini + 2 Then Exit For
   End If
  End If
  
 Next a

End Sub

'/////////////////////////////////////////////////////////////////////////
'Con el primer paso de las blancas llama al segundo paso de las negras/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub primeras_b(): Dim x As Long, y As Long, b As Long
 
 For b = uno To cont_b1
  
  For y = uno To ocho
   For x = uno To ocho
    casilla_b1(x, y) = b1(b, x, y)
   Next x
  Next y
  
  max2 = -infinito
  
  For y = uno To ocho
   For x = uno To ocho
    If aviso = True Then aviso = False: GoTo uno
    If casilla_b1(x, y) > cero Then movi_negras2 casilla_b1(), x, y
   Next x
  Next y

uno: If max2 <= min1 Then: min1 = max2: If min1 <= max1 Then Exit For
 
 Next b

End Sub

'/////////////////////////////////////////////////////////////////////////
'Encuentra las primeras negras/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub posibles_n1(x2 As Long, y2 As Long, x1 As Long, y1 As Long)
Dim x As Long, y As Long
 
 cont_n1 = cont_n1 + uno
 
 For y = uno To ocho
  For x = uno To ocho
   casilla_n1(x, y) = casilla(x, y)
  Next x
 Next y
 
 casilla_n1(x2, y2) = casilla_n1(x1, y1)
 casilla_n1(x1, y1) = cero
 If casilla_n1(x2, uno) = peon Then casilla_n1(x2, uno) = reina
 
 For y = uno To ocho
  For x = uno To ocho
   n1(cont_n1, x, y) = casilla_n1(x, y)
  Next x
 Next y

End Sub

'/////////////////////////////////////////////////////////////////////////
'Encuentra las primeras blancas/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub posibles_b1(x2 As Long, y2 As Long, x1 As Long, y1 As Long)
Dim x As Long, y As Long
 
 cont_b1 = cont_b1 + uno
 
 For y = uno To ocho
  For x = uno To ocho
   casilla_b1(x, y) = casilla_n1(x, y)
  Next x
 Next y
 
 casilla_b1(x2, y2) = casilla_b1(x1, y1)
 casilla_b1(x1, y1) = cero
 If casilla_b1(x2, ocho) = -peon Then casilla_b1(x2, ocho) = -reina
 
 For y = uno To ocho
  For x = uno To ocho
   b1(cont_b1, x, y) = casilla_b1(x, y)
  Next x
 Next y
 
End Sub

'/////////////////////////////////////////////////////////////////////////
'Encuentra las segundas negras y manda a llamar a las segundas blancas/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub posibles_n2(x2 As Long, y2 As Long, x1 As Long, y1 As Long)
Dim x As Long, y As Long
 
 For y = uno To ocho
  For x = uno To ocho
   casilla_n2(x, y) = casilla_b1(x, y)
  Next x
 Next y
 
 casilla_n2(x2, y2) = casilla_n2(x1, y1)
 casilla_n2(x1, y1) = cero
 If casilla_n2(x2, uno) = peon Then casilla_n2(x2, uno) = reina
 min2 = min1
 
 For y = ocho To uno Step -uno
  For x = uno To ocho
   If casilla_n2(x, y) < cero Then movi_blancas2 casilla_n2(), x, y
   If aviso = True Then: aviso = False: GoTo uno
  Next x
 Next y

uno: If min2 >= max2 Then: max2 = min2: If max2 >= min1 Then aviso = True

End Sub

'/////////////////////////////////////////////////////////////////////////
'Encuentra las segundas blancas y manda a llamar a las terceras negras/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub posibles_b2(x2 As Long, y2 As Long, x1 As Long, y1 As Long)
Dim x As Long, y As Long, valorp As Single
 
 For y = uno To ocho
  For x = uno To ocho
   casilla_b2(x, y) = casilla_n2(x, y)
  Next x
 Next y
 
 casilla_b2(x2, y2) = casilla_b2(x1, y1)
 casilla_b2(x1, y1) = cero
 If casilla_b2(x2, ocho) = -peon Then casilla_b2(x2, ocho) = -reina
 
 If tablero.difficult.Value = True Then
  
  max3 = max2
  For y = ocho To uno Step -uno
   For x = uno To ocho
    If casilla_b2(x, y) > cero Then movi_negras3 casilla_b2(), x, y
    If aviso = True Then: aviso = False: GoTo uno
   Next x
  Next y
uno:  If max3 <= min2 Then: min2 = max3: If min2 <= max2 Then aviso = True
  
  Else

   valorp = cero
   For y = uno To ocho
    For x = uno To ocho
     valorp = valorp + casilla_b2(x, y)
    Next x
   Next y
   If valorp < min2 Then
    min2 = valorp
    If min2 <= max2 Then aviso = True
   End If
  
  End If
End Sub

'/////////////////////////////////////////////////////////////////////////
'Encuentra las terceras negras y manda a llamar a las terceras blancas/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub posibles_n3(x2 As Long, y2 As Long, x1 As Long, y1 As Long)
Dim x As Long, y As Long
 
 For y = uno To ocho
  For x = uno To ocho
   casilla_n3(x, y) = casilla_b2(x, y)
  Next x
 Next y
 
 casilla_n3(x2, y2) = casilla_n3(x1, y1)
 casilla_n3(x1, y1) = cero
 If casilla_n3(x2, uno) = peon Then casilla_n3(x2, uno) = reina
 min3 = min2
 
 For y = ocho To uno Step -uno
  For x = uno To ocho
   If casilla_n3(x, y) < cero Then movi_blancas3 casilla_n3(), x, y
   If aviso = True Then aviso = False: GoTo uno
  Next x
 
 Next y
uno: If min3 >= max3 Then: max3 = min3: If max3 >= min2 Then aviso = True

End Sub

'/////////////////////////////////////////////////////////////////////////
'Encuentra las terceras blancas y evalua la jugada para ser comparada/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub posibles_b3(x2 As Long, y2 As Long, x1 As Long, y1 As Long)
Dim x As Long, y As Long, valorp As Single
 
 For y = uno To ocho
  For x = uno To ocho
   casilla_b3(x, y) = casilla_n3(x, y)
  Next x
 Next y
 
 casilla_b3(x2, y2) = casilla_b3(x1, y1)
 casilla_b3(x1, y1) = cero
 If casilla_b3(x2, ocho) = -peon Then casilla_b3(x2, ocho) = -reina
 valorp = cero
 
 For y = uno To ocho
  For x = uno To ocho
   valorp = valorp + casilla_b3(x, y)
  Next x
 Next y

uno: If valorp < min3 Then
      min3 = valorp
      If min3 <= max3 Then aviso = True
     End If
     
End Sub

'/////////////////////////////////////////////////////////////////////////
'Antes de dejar que le hagan el mate pelea hasta el final buscando la casilla vacia donde se salve inmediatamente sin ver ms al futuro/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub ultimo_recurso()
 Dim x As Long, y As Long
 
 per = False
 max1 = -infinito
 For x = uno To ocho
  For y = uno To ocho
   movi_negras4 casilla(), x, y
  Next y
 Next x
 
 If max1 < 0 Then
  copiar casilla_me(), casilla()
  MsgBox ("Computer resignes")
 End If

End Sub

'/////////////////////////////////////////////////////////////////////////
'Encuentra movimientos negros para procesos secundarios/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub posibles_n4(x2 As Long, y2 As Long, x1 As Long, y1 As Long)
 Dim x As Long, y As Long, valorp As Single
 
 If per = True Then permitido2(x2, y2) = uno: Exit Sub
 copiar casilla_n1(), casilla()
 movimiento casilla_n1(), x1, y1, x2, y2
 min1 = infinito
 per = False
 
 For x = uno To ocho
  For y = uno To ocho
   movi_blancas4 casilla_n1(), x, y
  Next y
 Next x
 
 If min1 > max1 Then
  max1 = min1
  copiar casilla_me(), casilla_n1()
 End If

End Sub

'/////////////////////////////////////////////////////////////////////////
'Encuentra los movimientos blancos para procesos secundarios/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
Public Sub posibles_b4(x2 As Long, y2 As Long, x1 As Long, y1 As Long)
 Dim x As Long, y As Long, valorp As Single
 
 If per = True Then permitido(x2, y2) = uno: Exit Sub
 copiar casilla_b1(), casilla_n1()
 movimiento casilla_b1(), x1, y1, x2, y2
 valorp = cero
 
 For y = uno To ocho
  For x = uno To ocho
   valorp = valorp + casilla_b1(x, y)
  Next x
 Next y
 
 If valorp < min1 Then min1 = valorp

End Sub

'/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////








